/**
 ** FILLCIRC.C
 **
 **  Copyright (C) 1992, Csaba Biegl
 **    820 Stirrup Dr, Nashville, TN, 37221
 **    csaba@vuse.vanderbilt.edu
 **
 **  This file is distributed under the terms listed in the document
 **  "copying.cb", available from the author at the address above.
 **  A copy of "copying.cb" should accompany this file; if not, a copy
 **  should be available from where this file was obtained.  This file
 **  may not be distributed without a verbatim copy of "copying.cb".
 **  You should also have received a copy of the GNU General Public
 **  License along with this program (it is in the file "copying");
 **  if not, write to the Free Software Foundation, Inc., 675 Mass Ave,
 **  Cambridge, MA 02139, USA.
 **
 **  This program is distributed in the hope that it will be useful,
 **  but WITHOUT ANY WARRANTY; without even the implied warranty of
 **  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 **  GNU General Public License for more details.
 **/

#include "grx.h"
#include "libgrx.h"
#include "clipping.h"

void GrFilledEllipse(int xc,int yc,int xa,int ya,int c)
{
	int pt[MAX_ELLIPSE_PTS+1][2];
	int x1,x2,y1,y2;
	MOUSE_FLAG;

	if(xa < 0) xa = (-xa);
	if(ya < 0) ya = (-ya);
	x1 = xc - xa; y1 = yc - ya;
	x2 = xc + xa; y2 = yc + ya;
	CLIPSORTEDBOX(CURC,x1,y1,x2,y2);
	MOUSE_BLOCK(CURC,x1,y1,x2,y2);
	if(ya == 0) {
	    if(xa == 0) GrPlot(xc,yc,c);
	    else	GrHLine(xc-xa,xc+xa,yc,c);
	}
	else if(xa == 0) {
	    GrVLine(xc,yc-ya,yc+ya,c);
	}
	else {
	    _GrScanConvexPoly(_GrGenerateEllipse(pt,xc,yc,xa,ya),pt,_GrScanLineFill,&c);
	}
	MOUSE_UNBLOCK();
}

void GrFilledCircle(int xc,int yc,int r,int c)
{
	GrFilledEllipse(xc,yc,r,r,c);
}

