/**
 ** PATFCVXP.C
 **
 **  Copyright (C) 1992, Csaba Biegl
 **    820 Stirrup Dr, Nashville, TN, 37221
 **    csaba@vuse.vanderbilt.edu
 **
 **  This file is distributed under the terms listed in the document
 **  "copying.cb", available from the author at the address above.
 **  A copy of "copying.cb" should accompany this file; if not, a copy
 **  should be available from where this file was obtained.  This file
 **  may not be distributed without a verbatim copy of "copying.cb".
 **  You should also have received a copy of the GNU General Public
 **  License along with this program (it is in the file "copying");
 **  if not, write to the Free Software Foundation, Inc., 675 Mass Ave,
 **  Cambridge, MA 02139, USA.
 **
 **  This program is distributed in the hope that it will be useful,
 **  but WITHOUT ANY WARRANTY; without even the implied warranty of
 **  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 **  GNU General Public License for more details.
 **/

#include "grx.h"
#include "libgrx.h"

void GrPatternFilledConvexPolygon(int n,int pt[][2],GrPattern *p)
{
	if(n <= 0) return;
	if((n > 1) && (pt[0][0] == pt[n-1][0]) && (pt[0][1] == pt[n-1][1])) n--;
	switch(n) {
	  case 1:
	    GrPatternFilledPlot(pt[0][0],pt[0][1],p);
	    break;
	  case 2:
	    GrPatternFilledLine(pt[0][0],pt[0][1],pt[1][0],pt[1][1],p);
	    break;
	  default:
	    _GrScanConvexPoly(n,pt,_GrScanLinePatternFill,p);
	    break;
	}
}

