/**
 ** _TODO.C
 **
 **  Copyright (C) 1992, Csaba Biegl
 **    820 Stirrup Dr, Nashville, TN, 37221
 **    csaba@vuse.vanderbilt.edu
 **
 **  This file is distributed under the terms listed in the document
 **  "copying.cb", available from the author at the address above.
 **  A copy of "copying.cb" should accompany this file; if not, a copy
 **  should be available from where this file was obtained.  This file
 **  may not be distributed without a verbatim copy of "copying.cb".
 **  You should also have received a copy of the GNU General Public
 **  License along with this program (it is in the file "copying");
 **  if not, write to the Free Software Foundation, Inc., 675 Mass Ave,
 **  Cambridge, MA 02139, USA.
 **
 **  This program is distributed in the hope that it will be useful,
 **  but WITHOUT ANY WARRANTY; without even the implied warranty of
 **  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 **  GNU General Public License for more details.
 **/

#include "grx.h"
#include "mousex.h"
#include <stdio.h>

#ifdef  __TURBOC__
#pragma warn -par
#endif

/* ================================================================== */
/*	      THICK AND DASHED LINE DRAWING PRIMITIVES		      */
/* ================================================================== */

void GrCustomLine(int x1,int y1,int x2,int y2,GrLineOption *o)
{
	GrLine(x1,y1,x2,y2,o->lno_color);
}

void GrCustomBox(int x1,int y1,int x2,int y2,GrLineOption *o)
{
	GrBox(x1,y1,x2,y2,o->lno_color);
}

void GrCustomCircle(int xc,int yc,int r,GrLineOption *o)
{
	GrCircle(xc,yc,r,o->lno_color);
}

void GrCustomEllipse(int xc,int yc,int xa,int ya,GrLineOption *o)
{
	GrEllipse(xc,yc,xa,ya,o->lno_color);
}

void GrCustomCircleArc(int xc,int yc,int r,int start,int end,GrLineOption *o)
{
	GrCircleArc(xc,yc,r,start,end,o->lno_color);
}

void GrCustomEllipseArc(int xc,int yc,int xa,int ya,int start,int end,GrLineOption *o)
{
	GrEllipseArc(xc,yc,xa,ya,start,end,o->lno_color);
}

void GrCustomPolyLine(int numpts,int points[][2],GrLineOption *o)
{
	GrPolyLine(numpts,points,o->lno_color);
}

void	GrCustomPolygon(int numpts,int points[][2],GrLineOption *o)
{
	GrPolygon(numpts,points,o->lno_color);
}



/* ================================================================== */
/*	       PATTERNED DRAWING AND FILLING PRIMITIVES		      */
/* ================================================================== */

GrPattern *GrLoadBitmap(char *filename,int fg,int bg) { return(NULL); }
GrPattern *GrLoadPixmap(char *filename,GrColorTableP colors) { return(NULL); }
GrPattern *GrLoadIcon(char *filename) { return(NULL); }

void	GrPatternedLine(int x1,int y1,int x2,int y2,GrLinePattern *lp)
{
	GrLine(x1,y1,x2,y2,lp->lnp_option->lno_color);
}

void	GrPatternedBox(int x1,int y1,int x2,int y2,GrLinePattern *lp)
{
	GrBox(x1,y1,x2,y2,lp->lnp_option->lno_color);
}

void	GrPatternedCircle(int xc,int yc,int r,GrLinePattern *lp) {}
void	GrPatternedEllipse(int xc,int yc,int xa,int ya,GrLinePattern *lp) {}
void	GrPatternedCircleArc
	(int xc,int yc,int r,int start,int end,GrLinePattern *lp) {}
void	GrPatternedEllipseArc
	(int xc,int yc,int xa,int ya,int start,int end,GrLinePattern *lp) {}
void	GrPatternedPolyLine(int numpts,int points[][2],GrLinePattern *lp) {}
void	GrPatternedPolygon(int numpts,int points[][2],GrLinePattern *lp) {}


/* ================================================================== */
/*		 DRAWING IN USER WINDOW COORDINATES		      */
/* ================================================================== */

void	GrUsrCircleArc(int xc,int yc,int r,int start,int end,int c) {}
void	GrUsrEllipseArc(int xc,int yc,int xa,int ya,int start,int end,int c) {}
void	GrUsrPolyLine(int numpts,int points[][2],int c) {}
void	GrUsrPolygon(int numpts,int points[][2],int c) {}

void	GrUsrFilledCircleArc(int xc,int yc,int r,int start,int end,int c) {}
void	GrUsrFilledEllipseArc
	(int xc,int yc,int xa,int ya,int start,int end,int c) {}
void	GrUsrFilledPolygon(int numpts,int points[][2],int c) {}

void	GrUsrCustomLine(int x1,int y1,int x2,int y2,GrLineOption *o) {}
void	GrUsrCustomBox(int x1,int y1,int x2,int y2,GrLineOption *o) {}
void	GrUsrCustomCircle(int xc,int yc,int r,GrLineOption *o) {}
void	GrUsrCustomEllipse(int xc,int yc,int xa,int ya,GrLineOption *o) {}
void	GrUsrCustomCircleArc
	(int xc,int yc,int r,int start,int end,GrLineOption *o) {}
void	GrUsrCustomEllipseArc
	(int xc,int yc,int xa,int ya,int start,int end,GrLineOption *o) {}
void	GrUsrCustomPolyLine(int numpts,int points[][2],GrLineOption *o) {}
void	GrUsrCustomPolygon(int numpts,int points[][2],GrLineOption *o) {}

void	GrUsrPatternedLine(int x1,int y1,int x2,int y2,GrLinePattern *lp) {}
void	GrUsrPatternedBox(int x1,int y1,int x2,int y2,GrLinePattern *lp) {}
void	GrUsrPatternedCircle(int xc,int yc,int r,GrLinePattern *lp) {}
void	GrUsrPatternedEllipse(int xc,int yc,int xa,int ya,GrLinePattern *lp) {}
void	GrUsrPatternedCircleArc
	(int xc,int yc,int r,int start,int end,GrLinePattern *lp) {}
void	GrUsrPatternedEllipseArc
	(int xc,int yc,int xa,int ya,int start,int end,GrLinePattern *lp) {}
void	GrUsrPatternedPolyLine(int numpts,int points[][2],GrLinePattern *lp) {}
void	GrUsrPatternedPolygon(int numpts,int points[][2],GrLinePattern *lp) {}

void	GrUsrPatternFilledPlot(int x,int y,GrPattern *p) {}
void	GrUsrPatternFilledLine(int x1,int y1,int x2,int y2,GrPattern *p) {}
void	GrUsrPatternFilledBox(int x1,int y1,int x2,int y2,GrPattern *p) {}
void	GrUsrPatternFilledCircle(int xc,int yc,int r,GrPattern *p) {}
void	GrUsrPatternFilledEllipse(int xc,int yc,int xa,int ya,GrPattern *p) {}
void	GrUsrPatternFilledCircleArc
	(int xc,int yc,int r,int start,int end,GrPattern *p) {}
void	GrUsrPatternFilledEllipseArc
	(int xc,int yc,int xa,int ya,int start,int end,GrPattern *p) {}
void	GrUsrPatternFilledPolygon(int numpts,int points[][2],GrPattern *p) {}

/*
 * FROM "mousex.h":
 */
GrCursor *GrLoadCursor(char *fname,GrColorTableP colors) { return(NULL); }


